Open In App

C# Program For Finding Intersection Point Of Two Linked Lists

Improve
Improve
Like Article
Like
Save
Share
Report

There are two singly linked lists in a system. By some programming error, the end node of one of the linked lists got linked to the second list, forming an inverted Y-shaped list. Write a program to get the point where two linked lists merge. 

Y ShapedLinked List

Above diagram shows an example with two linked lists having 15 as intersection points.

Method 1(Simply use two loops): 
Use 2 nested for loops. The outer loop will be for each node of the 1st list and the inner loop will be for the 2nd list. In the inner loop, check if any of the nodes of the 2nd list is the same as the current node of the first linked list. The time complexity of this method will be O(M * N) where m and n are the numbers of nodes in two lists.

Method 2 (Mark Visited Nodes): 
This solution requires modifications to basic linked list data structure. Have a visited flag with each node. Traverse the first linked list and keep marking visited nodes. Now traverse the second linked list, If you see a visited node again then there is an intersection point, return the intersecting node. This solution works in O(m+n) but requires additional information with each node. A variation of this solution that doesn’t require modification to the basic data structure can be implemented using a hash. Traverse the first linked list and store the addresses of visited nodes in a hash. Now traverse the second linked list and if you see an address that already exists in the hash then return the intersecting node.

Method 3(Using difference of node counts): 

  • Get count of the nodes in the first list, let count be c1.
  • Get count of the nodes in the second list, let count be c2.
  • Get the difference of counts d = abs(c1 – c2)
  • Now traverse the bigger list from the first node till d nodes so that from here onwards both the lists have equal no of nodes
  • Then we can traverse both the lists in parallel till we come across a common node. (Note that getting a common node is done by comparing the address of the nodes)

Below image is a dry run of the above approach:

Below is the implementation of the above approach :

C#




// C# program to get intersection point
// of two linked list
using System;
class LinkedList
{
    Node head1, head2;
    public class Node
    {
        public int data;
        public Node next;
 
        public Node(int d)
        {
            data = d;
            next = null;
        }
    }
 
    /* Function to get the intersection
       point of two linked lists head1
       and head2 */
    int getNode()
    {
        int c1 = getCount(head1);
        int c2 = getCount(head2);
        int d;
 
        if (c1 > c2)
        {
            d = c1 - c2;
            return _getIntesectionNode(d, head1,
                                       head2);
        }
        else
        {
            d = c2 - c1;
            return _getIntesectionNode(d, head2,
                                       head1);
        }
    }
 
    /* Function to get the intersection point
       of two linked lists head1 and head2
       where head1 has d more nodes than head2 */
    int _getIntesectionNode(int d, Node node1,
                            Node node2)
    {
        int i;
        Node current1 = node1;
        Node current2 = node2;
        for (i = 0; i < d; i++)
        {
            if (current1 == null)
            {
                return -1;
            }
            current1 = current1.next;
        }
        while (current1 != null &&
               current2 != null)
        {
            if (current1.data == current2.data)
            {
                return current1.data;
            }
            current1 = current1.next;
            current2 = current2.next;
        }
 
        return -1;
    }
 
    /* Takes head pointer of the linked list
       and returns the count of nodes in
       the list */
    int getCount(Node node)
    {
        Node current = node;
        int count = 0;
 
        while (current != null)
        {
            count++;
            current = current.next;
        }
 
        return count;
    }
 
    public static void Main(String[] args)
    {
        LinkedList list = new LinkedList();
 
        // creating first linked list
        list.head1 = new Node(3);
        list.head1.next = new Node(6);
        list.head1.next.next = new Node(9);
        list.head1.next.next.next = new Node(15);
        list.head1.next.next.next.next = new Node(30);
 
        // creating second linked list
        list.head2 = new Node(10);
        list.head2.next = new Node(15);
        list.head2.next.next = new Node(30);
 
        Console.WriteLine("The node of intersection is " +
                           list.getNode());
    }
}
// This code is contributed by Arnab Kundu


Output:

The node of intersection is 15

Time Complexity: O(m+n) 
Auxiliary Space: O(1)

Method 4(Make circle in first list): 
Thanks to Saravanan Man for providing below solution. 
1. Traverse the first linked list(count the elements) and make a circular linked list. (Remember the last node so that we can break the circle later on). 
2. Now view the problem as finding the loop in the second linked list. So the problem is solved. 
3. Since we already know the length of the loop(size of the first linked list) we can traverse those many numbers of nodes in the second list, and then start another pointer from the beginning of the second list. we have to traverse until they are equal, and that is the required intersection point. 
4. remove the circle from the linked list. 

Time Complexity: O(m+n) 
Auxiliary Space: O(1)

Method 5 (Reverse the first list and make equations): 
Thanks to Saravanan Mani for providing this method.  

1) Let X be the length of the first linked list until the intersection point.
   Let Y be the length of the second linked list until the intersection point.
   Let Z be the length of the linked list from the intersection point to End of
   the linked list including the intersection node.
   We Have
           X + Z = C1;
           Y + Z = C2;
2) Reverse first linked list.
3) Traverse Second linked list. Let C3 be the length of second list - 1. 
     Now we have
        X + Y = C3
     We have 3 linear equations. By solving them, we get
       X = (C1 + C3 – C2)/2;
       Y = (C2 + C3 – C1)/2;
       Z = (C1 + C2 – C3)/2;
      WE GOT THE INTERSECTION POINT.
4)  Reverse first linked list.

Advantage: No Comparison of pointers. 
Disadvantage: Modifying linked list(Reversing list). 
Time complexity: O(m+n) 
Auxiliary Space: O(1)

Method 6 (Traverse both lists and compare addresses of last nodes): This method is only to detect if there is an intersection point or not. (Thanks to NeoTheSaviour for suggesting this)  

1) Traverse list 1, store the last node address
2) Traverse list 2, store the last node address.
3) If nodes stored in 1 and 2 are same then they are intersecting.

The time complexity of this method is O(m+n) and used Auxiliary space is O(1)

Method 7 (Use Hashing): 
Basically, we need to find a common node of two linked lists. So we hash all nodes of the first list and then check the second list. 
1) Create an empty hash set. 
2) Traverse the first linked list and insert all nodes’ addresses in the hash set. 
3) Traverse the second list. For every node check if it is present in the hash set. If we find a node in the hash set, return the node.

C#




// C# program to get intersection
// point of two linked list
using System;
using System.Collections.Generic;
 
public class Node
{
    public int data;
    public Node next;
    public Node(int d)
    {
        data = d;
        next = null;
    }
}
public class LinkedListIntersect
{
    public static void Main(String[] args)
    {
        // list 1
        Node n1 = new Node(1);
        n1.next = new Node(2);
        n1.next.next = new Node(3);
        n1.next.next.next = new Node(4);
        n1.next.next.next.next = new Node(5);
        n1.next.next.next.next.next = new Node(6);
        n1.next.next.next.next.next.next = new Node(7);
 
        // list 2
        Node n2 = new Node(10);
        n2.next = new Node(9);
        n2.next.next = new Node(8);
        n2.next.next.next = n1.next.next.next;
        Print(n1);
        Print(n2);
        Console.WriteLine(MegeNode(n1, n2).data);
    }
 
    // Function to print the list
    public static void Print(Node n)
    {
        Node cur = n;
        while (cur != null)
        {
            Console.Write(cur.data + " ");
            cur = cur.next;
        }
        Console.WriteLine();
    }
 
    // function to find the intersection
    // of two node
    public static Node MegeNode(Node n1,
                                Node n2)
    {
        // Define hashset
        HashSet<Node> hs = new HashSet<Node>();
        while (n1 != null)
        {
            hs.Add(n1);
            n1 = n1.next;
        }
        while (n2 != null)
        {
            if (hs.Contains(n2))
            {
                return n2;
            }
            n2 = n2.next;
        }
        return null;
    }
}
// This code is contributed by 29AjayKumar


Output:

1  2  3  4  5  6  7  
10  9  8  4  5  6  7  
4

This method required O(n) additional space and not very efficient if one list is large.

Time complexity: O(n) where n is size of the hash

Please refer complete article on Write a function to get the intersection point of two Linked Lists for more details!



Last Updated : 24 Jun, 2022
Like Article
Save Article
Previous
Next
Share your thoughts in the comments
Similar Reads